<?php

namespace WsChronopost\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for creerEnlevementEurope StructType
 * Meta information extracted from the WSDL
 * - type: tns:creerEnlevementEurope
 * @package WsChronopost
 * @subpackage Structs
 */
class WsChronopostCreerEnlevementEurope extends AbstractStructBase
{
    /**
     * The headerValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostHeaderValue
     */
    public $headerValue;
    /**
     * The password
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The datePassage
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $datePassage;
    /**
     * The donneurDOrdre
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostDonneurDOrdre
     */
    public $donneurDOrdre;
    /**
     * The adresseEnlevement
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostAdresseEnlevementV3
     */
    public $adresseEnlevement;
    /**
     * The destinatairesEsd
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostDestinatairesDpd
     */
    public $destinatairesEsd;
    /**
     * The locale
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $locale;
    /**
     * Constructor method for creerEnlevementEurope
     * @uses WsChronopostCreerEnlevementEurope::setHeaderValue()
     * @uses WsChronopostCreerEnlevementEurope::setPassword()
     * @uses WsChronopostCreerEnlevementEurope::setDatePassage()
     * @uses WsChronopostCreerEnlevementEurope::setDonneurDOrdre()
     * @uses WsChronopostCreerEnlevementEurope::setAdresseEnlevement()
     * @uses WsChronopostCreerEnlevementEurope::setDestinatairesEsd()
     * @uses WsChronopostCreerEnlevementEurope::setLocale()
     * @param \WsChronopost\StructType\WsChronopostHeaderValue $headerValue
     * @param string $password
     * @param string $datePassage
     * @param \WsChronopost\StructType\WsChronopostDonneurDOrdre $donneurDOrdre
     * @param \WsChronopost\StructType\WsChronopostAdresseEnlevementV3 $adresseEnlevement
     * @param \WsChronopost\StructType\WsChronopostDestinatairesDpd $destinatairesEsd
     * @param string $locale
     */
    public function __construct(\WsChronopost\StructType\WsChronopostHeaderValue $headerValue = null, $password = null, $datePassage = null, \WsChronopost\StructType\WsChronopostDonneurDOrdre $donneurDOrdre = null, \WsChronopost\StructType\WsChronopostAdresseEnlevementV3 $adresseEnlevement = null, \WsChronopost\StructType\WsChronopostDestinatairesDpd $destinatairesEsd = null, $locale = null)
    {
        $this
            ->setHeaderValue($headerValue)
            ->setPassword($password)
            ->setDatePassage($datePassage)
            ->setDonneurDOrdre($donneurDOrdre)
            ->setAdresseEnlevement($adresseEnlevement)
            ->setDestinatairesEsd($destinatairesEsd)
            ->setLocale($locale);
    }
    /**
     * Get headerValue value
     * @return \WsChronopost\StructType\WsChronopostHeaderValue|null
     */
    public function getHeaderValue()
    {
        return $this->headerValue;
    }
    /**
     * Set headerValue value
     * @param \WsChronopost\StructType\WsChronopostHeaderValue $headerValue
     * @return \WsChronopost\StructType\WsChronopostCreerEnlevementEurope
     */
    public function setHeaderValue(\WsChronopost\StructType\WsChronopostHeaderValue $headerValue = null)
    {
        $this->headerValue = $headerValue;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \WsChronopost\StructType\WsChronopostCreerEnlevementEurope
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get datePassage value
     * @return string|null
     */
    public function getDatePassage()
    {
        return $this->datePassage;
    }
    /**
     * Set datePassage value
     * @param string $datePassage
     * @return \WsChronopost\StructType\WsChronopostCreerEnlevementEurope
     */
    public function setDatePassage($datePassage = null)
    {
        // validation for constraint: string
        if (!is_null($datePassage) && !is_string($datePassage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($datePassage, true), gettype($datePassage)), __LINE__);
        }
        $this->datePassage = $datePassage;
        return $this;
    }
    /**
     * Get donneurDOrdre value
     * @return \WsChronopost\StructType\WsChronopostDonneurDOrdre|null
     */
    public function getDonneurDOrdre()
    {
        return $this->donneurDOrdre;
    }
    /**
     * Set donneurDOrdre value
     * @param \WsChronopost\StructType\WsChronopostDonneurDOrdre $donneurDOrdre
     * @return \WsChronopost\StructType\WsChronopostCreerEnlevementEurope
     */
    public function setDonneurDOrdre(\WsChronopost\StructType\WsChronopostDonneurDOrdre $donneurDOrdre = null)
    {
        $this->donneurDOrdre = $donneurDOrdre;
        return $this;
    }
    /**
     * Get adresseEnlevement value
     * @return \WsChronopost\StructType\WsChronopostAdresseEnlevementV3|null
     */
    public function getAdresseEnlevement()
    {
        return $this->adresseEnlevement;
    }
    /**
     * Set adresseEnlevement value
     * @param \WsChronopost\StructType\WsChronopostAdresseEnlevementV3 $adresseEnlevement
     * @return \WsChronopost\StructType\WsChronopostCreerEnlevementEurope
     */
    public function setAdresseEnlevement(\WsChronopost\StructType\WsChronopostAdresseEnlevementV3 $adresseEnlevement = null)
    {
        $this->adresseEnlevement = $adresseEnlevement;
        return $this;
    }
    /**
     * Get destinatairesEsd value
     * @return \WsChronopost\StructType\WsChronopostDestinatairesDpd|null
     */
    public function getDestinatairesEsd()
    {
        return $this->destinatairesEsd;
    }
    /**
     * Set destinatairesEsd value
     * @param \WsChronopost\StructType\WsChronopostDestinatairesDpd $destinatairesEsd
     * @return \WsChronopost\StructType\WsChronopostCreerEnlevementEurope
     */
    public function setDestinatairesEsd(\WsChronopost\StructType\WsChronopostDestinatairesDpd $destinatairesEsd = null)
    {
        $this->destinatairesEsd = $destinatairesEsd;
        return $this;
    }
    /**
     * Get locale value
     * @return string|null
     */
    public function getLocale()
    {
        return $this->locale;
    }
    /**
     * Set locale value
     * @param string $locale
     * @return \WsChronopost\StructType\WsChronopostCreerEnlevementEurope
     */
    public function setLocale($locale = null)
    {
        // validation for constraint: string
        if (!is_null($locale) && !is_string($locale)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($locale, true), gettype($locale)), __LINE__);
        }
        $this->locale = $locale;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \WsChronopost\StructType\WsChronopostCreerEnlevementEurope
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
