<?php

namespace WsChronopost\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getReservedSkybillWithTypeAndModeAuth StructType
 * Meta information extracted from the WSDL
 * - type: tns:getReservedSkybillWithTypeAndModeAuth
 * @package WsChronopost
 * @subpackage Structs
 */
class WsChronopostGetReservedSkybillWithTypeAndModeAuth extends AbstractStructBase
{
    /**
     * The numberSearch
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $numberSearch;
    /**
     * The mode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mode;
    /**
     * The accountNumber
     * @var int
     */
    public $accountNumber;
    /**
     * The password
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * Constructor method for getReservedSkybillWithTypeAndModeAuth
     * @uses WsChronopostGetReservedSkybillWithTypeAndModeAuth::setNumberSearch()
     * @uses WsChronopostGetReservedSkybillWithTypeAndModeAuth::setMode()
     * @uses WsChronopostGetReservedSkybillWithTypeAndModeAuth::setAccountNumber()
     * @uses WsChronopostGetReservedSkybillWithTypeAndModeAuth::setPassword()
     * @param string $numberSearch
     * @param string $mode
     * @param int $accountNumber
     * @param string $password
     */
    public function __construct($numberSearch = null, $mode = null, $accountNumber = null, $password = null)
    {
        $this
            ->setNumberSearch($numberSearch)
            ->setMode($mode)
            ->setAccountNumber($accountNumber)
            ->setPassword($password);
    }
    /**
     * Get numberSearch value
     * @return string|null
     */
    public function getNumberSearch()
    {
        return $this->numberSearch;
    }
    /**
     * Set numberSearch value
     * @param string $numberSearch
     * @return \WsChronopost\StructType\WsChronopostGetReservedSkybillWithTypeAndModeAuth
     */
    public function setNumberSearch($numberSearch = null)
    {
        // validation for constraint: string
        if (!is_null($numberSearch) && !is_string($numberSearch)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numberSearch, true), gettype($numberSearch)), __LINE__);
        }
        $this->numberSearch = $numberSearch;
        return $this;
    }
    /**
     * Get mode value
     * @return string|null
     */
    public function getMode()
    {
        return $this->mode;
    }
    /**
     * Set mode value
     * @param string $mode
     * @return \WsChronopost\StructType\WsChronopostGetReservedSkybillWithTypeAndModeAuth
     */
    public function setMode($mode = null)
    {
        // validation for constraint: string
        if (!is_null($mode) && !is_string($mode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mode, true), gettype($mode)), __LINE__);
        }
        $this->mode = $mode;
        return $this;
    }
    /**
     * Get accountNumber value
     * @return int|null
     */
    public function getAccountNumber()
    {
        return $this->accountNumber;
    }
    /**
     * Set accountNumber value
     * @param int $accountNumber
     * @return \WsChronopost\StructType\WsChronopostGetReservedSkybillWithTypeAndModeAuth
     */
    public function setAccountNumber($accountNumber = null)
    {
        // validation for constraint: int
        if (!is_null($accountNumber) && !(is_int($accountNumber) || ctype_digit($accountNumber))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($accountNumber, true), gettype($accountNumber)), __LINE__);
        }
        $this->accountNumber = $accountNumber;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \WsChronopost\StructType\WsChronopostGetReservedSkybillWithTypeAndModeAuth
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \WsChronopost\StructType\WsChronopostGetReservedSkybillWithTypeAndModeAuth
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
