<?php

namespace WsChronopost\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getShippingInformation StructType
 * Meta information extracted from the WSDL
 * - type: tns:getShippingInformation
 * @package WsChronopost
 * @subpackage Structs
 */
class WsChronopostGetShippingInformation extends AbstractStructBase
{
    /**
     * The headerValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostHeaderValue
     */
    public $headerValue;
    /**
     * The shipperValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostShipperValue
     */
    public $shipperValue;
    /**
     * The recipientValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostRecipientValue
     */
    public $recipientValue;
    /**
     * The skybillValueBase
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostSkybillValueBase
     */
    public $skybillValueBase;
    /**
     * The password
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * Constructor method for getShippingInformation
     * @uses WsChronopostGetShippingInformation::setHeaderValue()
     * @uses WsChronopostGetShippingInformation::setShipperValue()
     * @uses WsChronopostGetShippingInformation::setRecipientValue()
     * @uses WsChronopostGetShippingInformation::setSkybillValueBase()
     * @uses WsChronopostGetShippingInformation::setPassword()
     * @param \WsChronopost\StructType\WsChronopostHeaderValue $headerValue
     * @param \WsChronopost\StructType\WsChronopostShipperValue $shipperValue
     * @param \WsChronopost\StructType\WsChronopostRecipientValue $recipientValue
     * @param \WsChronopost\StructType\WsChronopostSkybillValueBase $skybillValueBase
     * @param string $password
     */
    public function __construct(\WsChronopost\StructType\WsChronopostHeaderValue $headerValue = null, \WsChronopost\StructType\WsChronopostShipperValue $shipperValue = null, \WsChronopost\StructType\WsChronopostRecipientValue $recipientValue = null, \WsChronopost\StructType\WsChronopostSkybillValueBase $skybillValueBase = null, $password = null)
    {
        $this
            ->setHeaderValue($headerValue)
            ->setShipperValue($shipperValue)
            ->setRecipientValue($recipientValue)
            ->setSkybillValueBase($skybillValueBase)
            ->setPassword($password);
    }
    /**
     * Get headerValue value
     * @return \WsChronopost\StructType\WsChronopostHeaderValue|null
     */
    public function getHeaderValue()
    {
        return $this->headerValue;
    }
    /**
     * Set headerValue value
     * @param \WsChronopost\StructType\WsChronopostHeaderValue $headerValue
     * @return \WsChronopost\StructType\WsChronopostGetShippingInformation
     */
    public function setHeaderValue(\WsChronopost\StructType\WsChronopostHeaderValue $headerValue = null)
    {
        $this->headerValue = $headerValue;
        return $this;
    }
    /**
     * Get shipperValue value
     * @return \WsChronopost\StructType\WsChronopostShipperValue|null
     */
    public function getShipperValue()
    {
        return $this->shipperValue;
    }
    /**
     * Set shipperValue value
     * @param \WsChronopost\StructType\WsChronopostShipperValue $shipperValue
     * @return \WsChronopost\StructType\WsChronopostGetShippingInformation
     */
    public function setShipperValue(\WsChronopost\StructType\WsChronopostShipperValue $shipperValue = null)
    {
        $this->shipperValue = $shipperValue;
        return $this;
    }
    /**
     * Get recipientValue value
     * @return \WsChronopost\StructType\WsChronopostRecipientValue|null
     */
    public function getRecipientValue()
    {
        return $this->recipientValue;
    }
    /**
     * Set recipientValue value
     * @param \WsChronopost\StructType\WsChronopostRecipientValue $recipientValue
     * @return \WsChronopost\StructType\WsChronopostGetShippingInformation
     */
    public function setRecipientValue(\WsChronopost\StructType\WsChronopostRecipientValue $recipientValue = null)
    {
        $this->recipientValue = $recipientValue;
        return $this;
    }
    /**
     * Get skybillValueBase value
     * @return \WsChronopost\StructType\WsChronopostSkybillValueBase|null
     */
    public function getSkybillValueBase()
    {
        return $this->skybillValueBase;
    }
    /**
     * Set skybillValueBase value
     * @param \WsChronopost\StructType\WsChronopostSkybillValueBase $skybillValueBase
     * @return \WsChronopost\StructType\WsChronopostGetShippingInformation
     */
    public function setSkybillValueBase(\WsChronopost\StructType\WsChronopostSkybillValueBase $skybillValueBase = null)
    {
        $this->skybillValueBase = $skybillValueBase;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \WsChronopost\StructType\WsChronopostGetShippingInformation
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \WsChronopost\StructType\WsChronopostGetShippingInformation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
