<?php

namespace WsChronopost\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for infoDouanieres StructType
 * @package WsChronopost
 * @subpackage Structs
 */
class WsChronopostInfoDouanieres extends AbstractStructBase
{
    /**
     * The devise
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $devise;
    /**
     * The montant
     * @var float
     */
    public $montant;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $type;
    /**
     * Constructor method for infoDouanieres
     * @uses WsChronopostInfoDouanieres::setDevise()
     * @uses WsChronopostInfoDouanieres::setMontant()
     * @uses WsChronopostInfoDouanieres::setType()
     * @param string $devise
     * @param float $montant
     * @param string $type
     */
    public function __construct($devise = null, $montant = null, $type = null)
    {
        $this
            ->setDevise($devise)
            ->setMontant($montant)
            ->setType($type);
    }
    /**
     * Get devise value
     * @return string|null
     */
    public function getDevise()
    {
        return $this->devise;
    }
    /**
     * Set devise value
     * @param string $devise
     * @return \WsChronopost\StructType\WsChronopostInfoDouanieres
     */
    public function setDevise($devise = null)
    {
        // validation for constraint: string
        if (!is_null($devise) && !is_string($devise)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($devise, true), gettype($devise)), __LINE__);
        }
        $this->devise = $devise;
        return $this;
    }
    /**
     * Get montant value
     * @return float|null
     */
    public function getMontant()
    {
        return $this->montant;
    }
    /**
     * Set montant value
     * @param float $montant
     * @return \WsChronopost\StructType\WsChronopostInfoDouanieres
     */
    public function setMontant($montant = null)
    {
        // validation for constraint: float
        if (!is_null($montant) && !(is_float($montant) || is_numeric($montant))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($montant, true), gettype($montant)), __LINE__);
        }
        $this->montant = $montant;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \WsChronopost\StructType\WsChronopostInfoDouanieres
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \WsChronopost\StructType\WsChronopostInfoDouanieres
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
