<?php

namespace WsChronopost\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for options StructType
 * @package WsChronopost
 * @subpackage Structs
 */
class WsChronopostOptions extends AbstractStructBase
{
    /**
     * The aviserSurRealisation
     * @var bool
     */
    public $aviserSurRealisation;
    /**
     * The chezUnTiers
     * @var bool
     */
    public $chezUnTiers;
    /**
     * The envoyerLtParMail
     * @var bool
     */
    public $envoyerLtParMail;
    /**
     * The LTaImprimerParChronopost
     * @var bool
     */
    public $LTaImprimerParChronopost;
    /**
     * Constructor method for options
     * @uses WsChronopostOptions::setAviserSurRealisation()
     * @uses WsChronopostOptions::setChezUnTiers()
     * @uses WsChronopostOptions::setEnvoyerLtParMail()
     * @uses WsChronopostOptions::setLTaImprimerParChronopost()
     * @param bool $aviserSurRealisation
     * @param bool $chezUnTiers
     * @param bool $envoyerLtParMail
     * @param bool $lTaImprimerParChronopost
     */
    public function __construct($aviserSurRealisation = null, $chezUnTiers = null, $envoyerLtParMail = null, $lTaImprimerParChronopost = null)
    {
        $this
            ->setAviserSurRealisation($aviserSurRealisation)
            ->setChezUnTiers($chezUnTiers)
            ->setEnvoyerLtParMail($envoyerLtParMail)
            ->setLTaImprimerParChronopost($lTaImprimerParChronopost);
    }
    /**
     * Get aviserSurRealisation value
     * @return bool|null
     */
    public function getAviserSurRealisation()
    {
        return $this->aviserSurRealisation;
    }
    /**
     * Set aviserSurRealisation value
     * @param bool $aviserSurRealisation
     * @return \WsChronopost\StructType\WsChronopostOptions
     */
    public function setAviserSurRealisation($aviserSurRealisation = null)
    {
        // validation for constraint: boolean
        if (!is_null($aviserSurRealisation) && !is_bool($aviserSurRealisation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($aviserSurRealisation, true), gettype($aviserSurRealisation)), __LINE__);
        }
        $this->aviserSurRealisation = $aviserSurRealisation;
        return $this;
    }
    /**
     * Get chezUnTiers value
     * @return bool|null
     */
    public function getChezUnTiers()
    {
        return $this->chezUnTiers;
    }
    /**
     * Set chezUnTiers value
     * @param bool $chezUnTiers
     * @return \WsChronopost\StructType\WsChronopostOptions
     */
    public function setChezUnTiers($chezUnTiers = null)
    {
        // validation for constraint: boolean
        if (!is_null($chezUnTiers) && !is_bool($chezUnTiers)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($chezUnTiers, true), gettype($chezUnTiers)), __LINE__);
        }
        $this->chezUnTiers = $chezUnTiers;
        return $this;
    }
    /**
     * Get envoyerLtParMail value
     * @return bool|null
     */
    public function getEnvoyerLtParMail()
    {
        return $this->envoyerLtParMail;
    }
    /**
     * Set envoyerLtParMail value
     * @param bool $envoyerLtParMail
     * @return \WsChronopost\StructType\WsChronopostOptions
     */
    public function setEnvoyerLtParMail($envoyerLtParMail = null)
    {
        // validation for constraint: boolean
        if (!is_null($envoyerLtParMail) && !is_bool($envoyerLtParMail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($envoyerLtParMail, true), gettype($envoyerLtParMail)), __LINE__);
        }
        $this->envoyerLtParMail = $envoyerLtParMail;
        return $this;
    }
    /**
     * Get LTaImprimerParChronopost value
     * @return bool|null
     */
    public function getLTaImprimerParChronopost()
    {
        return $this->LTaImprimerParChronopost;
    }
    /**
     * Set LTaImprimerParChronopost value
     * @param bool $lTaImprimerParChronopost
     * @return \WsChronopost\StructType\WsChronopostOptions
     */
    public function setLTaImprimerParChronopost($lTaImprimerParChronopost = null)
    {
        // validation for constraint: boolean
        if (!is_null($lTaImprimerParChronopost) && !is_bool($lTaImprimerParChronopost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($lTaImprimerParChronopost, true), gettype($lTaImprimerParChronopost)), __LINE__);
        }
        $this->LTaImprimerParChronopost = $lTaImprimerParChronopost;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \WsChronopost\StructType\WsChronopostOptions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
