<?php

namespace WsChronopost\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for resultEnlevementNational StructType
 * @package WsChronopost
 * @subpackage Structs
 */
class WsChronopostResultEnlevementNational extends AbstractStructBase
{
    /**
     * The codeErreur
     * @var int
     */
    public $codeErreur;
    /**
     * The infoEnlevement
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostInfoEnlevement
     */
    public $infoEnlevement;
    /**
     * The libelleErreur
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $libelleErreur;
    /**
     * Constructor method for resultEnlevementNational
     * @uses WsChronopostResultEnlevementNational::setCodeErreur()
     * @uses WsChronopostResultEnlevementNational::setInfoEnlevement()
     * @uses WsChronopostResultEnlevementNational::setLibelleErreur()
     * @param int $codeErreur
     * @param \WsChronopost\StructType\WsChronopostInfoEnlevement $infoEnlevement
     * @param string $libelleErreur
     */
    public function __construct($codeErreur = null, \WsChronopost\StructType\WsChronopostInfoEnlevement $infoEnlevement = null, $libelleErreur = null)
    {
        $this
            ->setCodeErreur($codeErreur)
            ->setInfoEnlevement($infoEnlevement)
            ->setLibelleErreur($libelleErreur);
    }
    /**
     * Get codeErreur value
     * @return int|null
     */
    public function getCodeErreur()
    {
        return $this->codeErreur;
    }
    /**
     * Set codeErreur value
     * @param int $codeErreur
     * @return \WsChronopost\StructType\WsChronopostResultEnlevementNational
     */
    public function setCodeErreur($codeErreur = null)
    {
        // validation for constraint: int
        if (!is_null($codeErreur) && !(is_int($codeErreur) || ctype_digit($codeErreur))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codeErreur, true), gettype($codeErreur)), __LINE__);
        }
        $this->codeErreur = $codeErreur;
        return $this;
    }
    /**
     * Get infoEnlevement value
     * @return \WsChronopost\StructType\WsChronopostInfoEnlevement|null
     */
    public function getInfoEnlevement()
    {
        return $this->infoEnlevement;
    }
    /**
     * Set infoEnlevement value
     * @param \WsChronopost\StructType\WsChronopostInfoEnlevement $infoEnlevement
     * @return \WsChronopost\StructType\WsChronopostResultEnlevementNational
     */
    public function setInfoEnlevement(\WsChronopost\StructType\WsChronopostInfoEnlevement $infoEnlevement = null)
    {
        $this->infoEnlevement = $infoEnlevement;
        return $this;
    }
    /**
     * Get libelleErreur value
     * @return string|null
     */
    public function getLibelleErreur()
    {
        return $this->libelleErreur;
    }
    /**
     * Set libelleErreur value
     * @param string $libelleErreur
     * @return \WsChronopost\StructType\WsChronopostResultEnlevementNational
     */
    public function setLibelleErreur($libelleErreur = null)
    {
        // validation for constraint: string
        if (!is_null($libelleErreur) && !is_string($libelleErreur)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($libelleErreur, true), gettype($libelleErreur)), __LINE__);
        }
        $this->libelleErreur = $libelleErreur;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \WsChronopost\StructType\WsChronopostResultEnlevementNational
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
