<?php

namespace WsChronopost\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for shipping StructType
 * Meta information extracted from the WSDL
 * - type: tns:shipping
 * @package WsChronopost
 * @subpackage Structs
 */
class WsChronopostShipping extends AbstractStructBase
{
    /**
     * The esdValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostEsdValue
     */
    public $esdValue;
    /**
     * The headerValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostHeaderValue
     */
    public $headerValue;
    /**
     * The shipperValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostShipperValue
     */
    public $shipperValue;
    /**
     * The customerValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostCustomerValue
     */
    public $customerValue;
    /**
     * The recipientValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostRecipientValue
     */
    public $recipientValue;
    /**
     * The refValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostRefValue
     */
    public $refValue;
    /**
     * The skybillValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostSkybillValue
     */
    public $skybillValue;
    /**
     * The skybillParamsValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WsChronopost\StructType\WsChronopostSkybillParamsValue
     */
    public $skybillParamsValue;
    /**
     * The password
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * Constructor method for shipping
     * @uses WsChronopostShipping::setEsdValue()
     * @uses WsChronopostShipping::setHeaderValue()
     * @uses WsChronopostShipping::setShipperValue()
     * @uses WsChronopostShipping::setCustomerValue()
     * @uses WsChronopostShipping::setRecipientValue()
     * @uses WsChronopostShipping::setRefValue()
     * @uses WsChronopostShipping::setSkybillValue()
     * @uses WsChronopostShipping::setSkybillParamsValue()
     * @uses WsChronopostShipping::setPassword()
     * @param \WsChronopost\StructType\WsChronopostEsdValue $esdValue
     * @param \WsChronopost\StructType\WsChronopostHeaderValue $headerValue
     * @param \WsChronopost\StructType\WsChronopostShipperValue $shipperValue
     * @param \WsChronopost\StructType\WsChronopostCustomerValue $customerValue
     * @param \WsChronopost\StructType\WsChronopostRecipientValue $recipientValue
     * @param \WsChronopost\StructType\WsChronopostRefValue $refValue
     * @param \WsChronopost\StructType\WsChronopostSkybillValue $skybillValue
     * @param \WsChronopost\StructType\WsChronopostSkybillParamsValue $skybillParamsValue
     * @param string $password
     */
    public function __construct(\WsChronopost\StructType\WsChronopostEsdValue $esdValue = null, \WsChronopost\StructType\WsChronopostHeaderValue $headerValue = null, \WsChronopost\StructType\WsChronopostShipperValue $shipperValue = null, \WsChronopost\StructType\WsChronopostCustomerValue $customerValue = null, \WsChronopost\StructType\WsChronopostRecipientValue $recipientValue = null, \WsChronopost\StructType\WsChronopostRefValue $refValue = null, \WsChronopost\StructType\WsChronopostSkybillValue $skybillValue = null, \WsChronopost\StructType\WsChronopostSkybillParamsValue $skybillParamsValue = null, $password = null)
    {
        $this
            ->setEsdValue($esdValue)
            ->setHeaderValue($headerValue)
            ->setShipperValue($shipperValue)
            ->setCustomerValue($customerValue)
            ->setRecipientValue($recipientValue)
            ->setRefValue($refValue)
            ->setSkybillValue($skybillValue)
            ->setSkybillParamsValue($skybillParamsValue)
            ->setPassword($password);
    }
    /**
     * Get esdValue value
     * @return \WsChronopost\StructType\WsChronopostEsdValue|null
     */
    public function getEsdValue()
    {
        return $this->esdValue;
    }
    /**
     * Set esdValue value
     * @param \WsChronopost\StructType\WsChronopostEsdValue $esdValue
     * @return \WsChronopost\StructType\WsChronopostShipping
     */
    public function setEsdValue(\WsChronopost\StructType\WsChronopostEsdValue $esdValue = null)
    {
        $this->esdValue = $esdValue;
        return $this;
    }
    /**
     * Get headerValue value
     * @return \WsChronopost\StructType\WsChronopostHeaderValue|null
     */
    public function getHeaderValue()
    {
        return $this->headerValue;
    }
    /**
     * Set headerValue value
     * @param \WsChronopost\StructType\WsChronopostHeaderValue $headerValue
     * @return \WsChronopost\StructType\WsChronopostShipping
     */
    public function setHeaderValue(\WsChronopost\StructType\WsChronopostHeaderValue $headerValue = null)
    {
        $this->headerValue = $headerValue;
        return $this;
    }
    /**
     * Get shipperValue value
     * @return \WsChronopost\StructType\WsChronopostShipperValue|null
     */
    public function getShipperValue()
    {
        return $this->shipperValue;
    }
    /**
     * Set shipperValue value
     * @param \WsChronopost\StructType\WsChronopostShipperValue $shipperValue
     * @return \WsChronopost\StructType\WsChronopostShipping
     */
    public function setShipperValue(\WsChronopost\StructType\WsChronopostShipperValue $shipperValue = null)
    {
        $this->shipperValue = $shipperValue;
        return $this;
    }
    /**
     * Get customerValue value
     * @return \WsChronopost\StructType\WsChronopostCustomerValue|null
     */
    public function getCustomerValue()
    {
        return $this->customerValue;
    }
    /**
     * Set customerValue value
     * @param \WsChronopost\StructType\WsChronopostCustomerValue $customerValue
     * @return \WsChronopost\StructType\WsChronopostShipping
     */
    public function setCustomerValue(\WsChronopost\StructType\WsChronopostCustomerValue $customerValue = null)
    {
        $this->customerValue = $customerValue;
        return $this;
    }
    /**
     * Get recipientValue value
     * @return \WsChronopost\StructType\WsChronopostRecipientValue|null
     */
    public function getRecipientValue()
    {
        return $this->recipientValue;
    }
    /**
     * Set recipientValue value
     * @param \WsChronopost\StructType\WsChronopostRecipientValue $recipientValue
     * @return \WsChronopost\StructType\WsChronopostShipping
     */
    public function setRecipientValue(\WsChronopost\StructType\WsChronopostRecipientValue $recipientValue = null)
    {
        $this->recipientValue = $recipientValue;
        return $this;
    }
    /**
     * Get refValue value
     * @return \WsChronopost\StructType\WsChronopostRefValue|null
     */
    public function getRefValue()
    {
        return $this->refValue;
    }
    /**
     * Set refValue value
     * @param \WsChronopost\StructType\WsChronopostRefValue $refValue
     * @return \WsChronopost\StructType\WsChronopostShipping
     */
    public function setRefValue(\WsChronopost\StructType\WsChronopostRefValue $refValue = null)
    {
        $this->refValue = $refValue;
        return $this;
    }
    /**
     * Get skybillValue value
     * @return \WsChronopost\StructType\WsChronopostSkybillValue|null
     */
    public function getSkybillValue()
    {
        return $this->skybillValue;
    }
    /**
     * Set skybillValue value
     * @param \WsChronopost\StructType\WsChronopostSkybillValue $skybillValue
     * @return \WsChronopost\StructType\WsChronopostShipping
     */
    public function setSkybillValue(\WsChronopost\StructType\WsChronopostSkybillValue $skybillValue = null)
    {
        $this->skybillValue = $skybillValue;
        return $this;
    }
    /**
     * Get skybillParamsValue value
     * @return \WsChronopost\StructType\WsChronopostSkybillParamsValue|null
     */
    public function getSkybillParamsValue()
    {
        return $this->skybillParamsValue;
    }
    /**
     * Set skybillParamsValue value
     * @param \WsChronopost\StructType\WsChronopostSkybillParamsValue $skybillParamsValue
     * @return \WsChronopost\StructType\WsChronopostShipping
     */
    public function setSkybillParamsValue(\WsChronopost\StructType\WsChronopostSkybillParamsValue $skybillParamsValue = null)
    {
        $this->skybillParamsValue = $skybillParamsValue;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \WsChronopost\StructType\WsChronopostShipping
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \WsChronopost\StructType\WsChronopostShipping
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
