<?php

namespace WsChronopost;

/**
 * Class which returns the class map definition
 * @package WsChronopost
 */
class WsChronopostClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'shipperValue' => '\\WsChronopost\\StructType\\WsChronopostShipperValue',
            'resultFaisabiliteESD' => '\\WsChronopost\\StructType\\WsChronopostResultFaisabiliteESD',
            'esdValue' => '\\WsChronopost\\StructType\\WsChronopostEsdValue',
            'headerValue' => '\\WsChronopost\\StructType\\WsChronopostHeaderValue',
            'customerValue' => '\\WsChronopost\\StructType\\WsChronopostCustomerValue',
            'recipientValue' => '\\WsChronopost\\StructType\\WsChronopostRecipientValue',
            'refValue' => '\\WsChronopost\\StructType\\WsChronopostRefValue',
            'skybillValue' => '\\WsChronopost\\StructType\\WsChronopostSkybillValue',
            'skybillParamsValue' => '\\WsChronopost\\StructType\\WsChronopostSkybillParamsValue',
            'resultExpeditionValue' => '\\WsChronopost\\StructType\\WsChronopostResultExpeditionValue',
            'resultGetReservedSkybillWithTypeValue' => '\\WsChronopost\\StructType\\WsChronopostResultGetReservedSkybillWithTypeValue',
            'donneurDOrdre' => '\\WsChronopost\\StructType\\WsChronopostDonneurDOrdre',
            'adresseEnlevement' => '\\WsChronopost\\StructType\\WsChronopostAdresseEnlevement',
            'adresseEnlevementV2' => '\\WsChronopost\\StructType\\WsChronopostAdresseEnlevementV2',
            'adresseEnlevementV3' => '\\WsChronopost\\StructType\\WsChronopostAdresseEnlevementV3',
            'particularitesEsd' => '\\WsChronopost\\StructType\\WsChronopostParticularitesEsd',
            'options' => '\\WsChronopost\\StructType\\WsChronopostOptions',
            'resultEnlevementNational' => '\\WsChronopost\\StructType\\WsChronopostResultEnlevementNational',
            'infoEnlevement' => '\\WsChronopost\\StructType\\WsChronopostInfoEnlevement',
            'scheduledValue' => '\\WsChronopost\\StructType\\WsChronopostScheduledValue',
            'appointmentValue' => '\\WsChronopost\\StructType\\WsChronopostAppointmentValue',
            'esdWithRefClientValue' => '\\WsChronopost\\StructType\\WsChronopostEsdWithRefClientValue',
            'esdValue3' => '\\WsChronopost\\StructType\\WsChronopostEsdValue3',
            'skybillWithDimensionsValue' => '\\WsChronopost\\StructType\\WsChronopostSkybillWithDimensionsValue',
            'skybillWithDimensionsValueV2' => '\\WsChronopost\\StructType\\WsChronopostSkybillWithDimensionsValueV2',
            'skybillWithDimensionsValueV3' => '\\WsChronopost\\StructType\\WsChronopostSkybillWithDimensionsValueV3',
            'skybillParamsValueV2' => '\\WsChronopost\\StructType\\WsChronopostSkybillParamsValueV2',
            'resultShippingValue' => '\\WsChronopost\\StructType\\WsChronopostResultShippingValue',
            'resultMultiParcelExpeditionValue' => '\\WsChronopost\\StructType\\WsChronopostResultMultiParcelExpeditionValue',
            'resultMultiParcelValue' => '\\WsChronopost\\StructType\\WsChronopostResultMultiParcelValue',
            'skybillValueV2' => '\\WsChronopost\\StructType\\WsChronopostSkybillValueV2',
            'resultReservationExpeditionValue' => '\\WsChronopost\\StructType\\WsChronopostResultReservationExpeditionValue',
            'resultReservationExpeditionValueV2' => '\\WsChronopost\\StructType\\WsChronopostResultReservationExpeditionValueV2',
            'resultGetReservedSkybillValue' => '\\WsChronopost\\StructType\\WsChronopostResultGetReservedSkybillValue',
            'resultReservationMultiParcelExpeditionValue' => '\\WsChronopost\\StructType\\WsChronopostResultReservationMultiParcelExpeditionValue',
            'resultParcelValue' => '\\WsChronopost\\StructType\\WsChronopostResultParcelValue',
            'shipperValueV2' => '\\WsChronopost\\StructType\\WsChronopostShipperValueV2',
            'recipientValueV2' => '\\WsChronopost\\StructType\\WsChronopostRecipientValueV2',
            'refValueV2' => '\\WsChronopost\\StructType\\WsChronopostRefValueV2',
            'skybillWithDimensionsValueV4' => '\\WsChronopost\\StructType\\WsChronopostSkybillWithDimensionsValueV4',
            'skybillWithDimensionsValueV5' => '\\WsChronopost\\StructType\\WsChronopostSkybillWithDimensionsValueV5',
            'skybillWithDimensionsValueV6' => '\\WsChronopost\\StructType\\WsChronopostSkybillWithDimensionsValueV6',
            'recipientLocalValue' => '\\WsChronopost\\StructType\\WsChronopostRecipientLocalValue',
            'recipientLocalValueV2' => '\\WsChronopost\\StructType\\WsChronopostRecipientLocalValueV2',
            'customsValue' => '\\WsChronopost\\StructType\\WsChronopostCustomsValue',
            'articleValue' => '\\WsChronopost\\StructType\\WsChronopostArticleValue',
            'resultReservationMultiParcelExpeditionValueV2' => '\\WsChronopost\\StructType\\WsChronopostResultReservationMultiParcelExpeditionValueV2',
            'resultExpeditionValueV3' => '\\WsChronopost\\StructType\\WsChronopostResultExpeditionValueV3',
            'resultMonoParcelExpeditionValue' => '\\WsChronopost\\StructType\\WsChronopostResultMonoParcelExpeditionValue',
            'esdResultContraintesAgenceValue' => '\\WsChronopost\\StructType\\WsChronopostEsdResultContraintesAgenceValue',
            'esdContraintesAgence' => '\\WsChronopost\\StructType\\WsChronopostEsdContraintesAgence',
            'destinatairesDpd' => '\\WsChronopost\\StructType\\WsChronopostDestinatairesDpd',
            'destinataireDpd' => '\\WsChronopost\\StructType\\WsChronopostDestinataireDpd',
            'adresseDestinataire' => '\\WsChronopost\\StructType\\WsChronopostAdresseDestinataire',
            'infoClient' => '\\WsChronopost\\StructType\\WsChronopostInfoClient',
            'particularites' => '\\WsChronopost\\StructType\\WsChronopostParticularites',
            'particularitesColisDpd' => '\\WsChronopost\\StructType\\WsChronopostParticularitesColisDpd',
            'infoDouanieres' => '\\WsChronopost\\StructType\\WsChronopostInfoDouanieres',
            'resultPickupOrCollectionRequest' => '\\WsChronopost\\StructType\\WsChronopostResultPickupOrCollectionRequest',
            'skybillValueBase' => '\\WsChronopost\\StructType\\WsChronopostSkybillValueBase',
            'resultShippingInfo' => '\\WsChronopost\\StructType\\WsChronopostResultShippingInfo',
            'error' => '\\WsChronopost\\StructType\\WsChronopostError',
            'detail' => '\\WsChronopost\\StructType\\WsChronopostDetail',
            'shippingInfo' => '\\WsChronopost\\StructType\\WsChronopostShippingInfo',
            'resultGetRouting' => '\\WsChronopost\\StructType\\WsChronopostResultGetRouting',
            'geopostResult' => '\\WsChronopost\\StructType\\WsChronopostGeopostResult',
            'faisabiliteESD' => '\\WsChronopost\\StructType\\WsChronopostFaisabiliteESD',
            'faisabiliteESDResponse' => '\\WsChronopost\\StructType\\WsChronopostFaisabiliteESDResponse',
            'shippingV2' => '\\WsChronopost\\StructType\\WsChronopostShippingV2',
            'shippingV2Response' => '\\WsChronopost\\StructType\\WsChronopostShippingV2Response',
            'getReservedSkybillWithTypeAndModeAuth' => '\\WsChronopost\\StructType\\WsChronopostGetReservedSkybillWithTypeAndModeAuth',
            'getReservedSkybillWithTypeAndModeAuthResponse' => '\\WsChronopost\\StructType\\WsChronopostGetReservedSkybillWithTypeAndModeAuthResponse',
            'getReservedSkybillWithType' => '\\WsChronopost\\StructType\\WsChronopostGetReservedSkybillWithType',
            'getReservedSkybillWithTypeResponse' => '\\WsChronopost\\StructType\\WsChronopostGetReservedSkybillWithTypeResponse',
            'creerEnlevementNational' => '\\WsChronopost\\StructType\\WsChronopostCreerEnlevementNational',
            'creerEnlevementNationalResponse' => '\\WsChronopost\\StructType\\WsChronopostCreerEnlevementNationalResponse',
            'shippingV3' => '\\WsChronopost\\StructType\\WsChronopostShippingV3',
            'shippingV3Response' => '\\WsChronopost\\StructType\\WsChronopostShippingV3Response',
            'getReservedSkybillWithTypeAndModeByReservation' => '\\WsChronopost\\StructType\\WsChronopostGetReservedSkybillWithTypeAndModeByReservation',
            'getReservedSkybillWithTypeAndModeByReservationResponse' => '\\WsChronopost\\StructType\\WsChronopostGetReservedSkybillWithTypeAndModeByReservationResponse',
            'shippingMultiParcel' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcel',
            'shippingMultiParcelResponse' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelResponse',
            'shippingWithReservationV2' => '\\WsChronopost\\StructType\\WsChronopostShippingWithReservationV2',
            'shippingWithReservationV2Response' => '\\WsChronopost\\StructType\\WsChronopostShippingWithReservationV2Response',
            'shipping' => '\\WsChronopost\\StructType\\WsChronopostShipping',
            'shippingResponse' => '\\WsChronopost\\StructType\\WsChronopostShippingResponse',
            'getReservedSkybill' => '\\WsChronopost\\StructType\\WsChronopostGetReservedSkybill',
            'getReservedSkybillResponse' => '\\WsChronopost\\StructType\\WsChronopostGetReservedSkybillResponse',
            'shippingMultiParcelWithReservation' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelWithReservation',
            'shippingMultiParcelWithReservationResponse' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelWithReservationResponse',
            'shippingMultiParcelV4' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelV4',
            'shippingMultiParcelV4Response' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelV4Response',
            'shippingMultiParcelWithReservationV3' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelWithReservationV3',
            'shippingMultiParcelWithReservationV3Response' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelWithReservationV3Response',
            'shippingMultiParcelV2' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelV2',
            'shippingMultiParcelV2Response' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelV2Response',
            'shippingV6' => '\\WsChronopost\\StructType\\WsChronopostShippingV6',
            'shippingV6Response' => '\\WsChronopost\\StructType\\WsChronopostShippingV6Response',
            'shippingWithReservation' => '\\WsChronopost\\StructType\\WsChronopostShippingWithReservation',
            'shippingWithReservationResponse' => '\\WsChronopost\\StructType\\WsChronopostShippingWithReservationResponse',
            'shippingV7' => '\\WsChronopost\\StructType\\WsChronopostShippingV7',
            'shippingV7Response' => '\\WsChronopost\\StructType\\WsChronopostShippingV7Response',
            'rechercherContraintesEnlevement' => '\\WsChronopost\\StructType\\WsChronopostRechercherContraintesEnlevement',
            'rechercherContraintesEnlevementResponse' => '\\WsChronopost\\StructType\\WsChronopostRechercherContraintesEnlevementResponse',
            'creerEnlevementEurope' => '\\WsChronopost\\StructType\\WsChronopostCreerEnlevementEurope',
            'creerEnlevementEuropeResponse' => '\\WsChronopost\\StructType\\WsChronopostCreerEnlevementEuropeResponse',
            'shippingWithReservationAndESDWithRefClient' => '\\WsChronopost\\StructType\\WsChronopostShippingWithReservationAndESDWithRefClient',
            'shippingWithReservationAndESDWithRefClientResponse' => '\\WsChronopost\\StructType\\WsChronopostShippingWithReservationAndESDWithRefClientResponse',
            'getReservedSkybillWithTypeAndMode' => '\\WsChronopost\\StructType\\WsChronopostGetReservedSkybillWithTypeAndMode',
            'getReservedSkybillWithTypeAndModeResponse' => '\\WsChronopost\\StructType\\WsChronopostGetReservedSkybillWithTypeAndModeResponse',
            'shippingV4' => '\\WsChronopost\\StructType\\WsChronopostShippingV4',
            'shippingV4Response' => '\\WsChronopost\\StructType\\WsChronopostShippingV4Response',
            'shippingWithReservationAndESDWithRefClientPC' => '\\WsChronopost\\StructType\\WsChronopostShippingWithReservationAndESDWithRefClientPC',
            'shippingWithReservationAndESDWithRefClientPCResponse' => '\\WsChronopost\\StructType\\WsChronopostShippingWithReservationAndESDWithRefClientPCResponse',
            'shippingV5' => '\\WsChronopost\\StructType\\WsChronopostShippingV5',
            'shippingV5Response' => '\\WsChronopost\\StructType\\WsChronopostShippingV5Response',
            'shippingMultiParcelWithReservationV2' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelWithReservationV2',
            'shippingMultiParcelWithReservationV2Response' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelWithReservationV2Response',
            'shippingWithESDOnly' => '\\WsChronopost\\StructType\\WsChronopostShippingWithESDOnly',
            'shippingWithESDOnlyResponse' => '\\WsChronopost\\StructType\\WsChronopostShippingWithESDOnlyResponse',
            'getShippingInformation' => '\\WsChronopost\\StructType\\WsChronopostGetShippingInformation',
            'getShippingInformationResponse' => '\\WsChronopost\\StructType\\WsChronopostGetShippingInformationResponse',
            'getRouting' => '\\WsChronopost\\StructType\\WsChronopostGetRouting',
            'getRoutingResponse' => '\\WsChronopost\\StructType\\WsChronopostGetRoutingResponse',
            'shippingMultiParcelV3' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelV3',
            'shippingMultiParcelV3Response' => '\\WsChronopost\\StructType\\WsChronopostShippingMultiParcelV3Response',
        );
    }
}
